/*
 * selectionSort lajittelee numeroita sisältävän taulukon alkiot suurimmasta
 * pienimpään tai pienimmästä suurimpaan ja palauttaa lajitellun taulukon.
 * selectionSort käyttää kahta apufunktiota jotka ovat findIndexOfSmallest
 * ja findIndexOfBiggest. Algoritmissa ei ole syntaksivirheitä, mutta se
 * palauttaa virheellisen lopputuloksen. Tarvitaan siis debuggausta.
 *
 * Debuggauksen voi tehdä console.log -lauseilla yksinkertaisissa tapauksissa,
 * mutta yleensä editorin debuggeri on parempi työkalu.
 *
 * Huomaa että JS:ssä on jo sisäänrakennettu sort() -metodi taulukon alkioiden
 * lajitteluun, mutta tämän esimerkin tarkoitus onkin vain esitellä debuggausta.
 */

function findIndexOfSmallest(arr) {
  // ... on spread operaattori joka hajottaa taulukon alkioiksi
  return arr.indexOf(Math.min(...arr));
}

function findIndexOfBiggest(arr) {
  return arr.indexOf(Math.max(...arr));
}

function selectionSort(arr, choice) {
  const newArray = [];
  const count = arr.length;
  let i;
  let arr1;
  let arr2;
  /* Silmukassa on tarkoituksena rakentaa newArray -taulukko
       jossa alkiot ovat lajiteltuina */
  for (i = 0; i < count; i++) {
    if (choice === 'smallest') {
      smallestIndex = findIndexOfSmallest(arr);
      //console.log(smallestIndex);
      newArray.push(arr[smallestIndex]);
      //console.log(newArray);
      arr1 = arr.slice(0, smallestIndex);
      arr2 = arr.slice(smallestIndex, arr.length);
      arr = arr1.concat(arr2);
      //console.log(arr);
    } else {
      biggestIndex = findIndexOfBiggest(arr);
      newArray.push(arr[biggestIndex]);
      arr1 = arr.slice(0, biggestIndex);
      arr2 = arr.slice(biggestIndex, arr.length);
      arr = arr1.concat(arr2);
    }
  }
  return newArray;
}

const myArray = [4, 3, 6, 5, 1, 9, 2, 8, 7];

const sortedArray = selectionSort(myArray, 'smallest');
console.log(sortedArray);
